﻿using System;

// Product abstract class
public abstract class Product
{
    public abstract void Operation();
}

// ConcreteProductA class
public class ConcreteProductA : Product
{
    public override void Operation()
    {
        Console.WriteLine("ConcreteProductA operation");
    }
}

// ConcreteProductB class
public class ConcreteProductB : Product
{
    public override void Operation()
    {
        Console.WriteLine("ConcreteProductB operation");
    }
}

// Creator abstract class
public abstract class Creator
{
    public abstract Product FactoryMethod();
}

// ConcreteCreatorA class
public class ConcreteCreatorA : Creator
{
    public override Product FactoryMethod()
    {
        return new ConcreteProductA();
    }
}

// ConcreteCreatorB class
public class ConcreteCreatorB : Creator
{
    public override Product FactoryMethod()
    {
        return new ConcreteProductB();
    }
}

class Program
{
    static void Main(string[] args)
    {
        //you can ask the user which concrete creator
        Creator creator = new ConcreteCreatorA();
        Product product = creator.FactoryMethod();
        product.Operation();

        creator = new ConcreteCreatorB();
        product = creator.FactoryMethod();
        product.Operation();
    }
}
